Step
Date: 2016-07-03

com.icl.saxon.expr

## Class Step

- java.lang.Object
- - com.icl.saxon.expr.Step

-     public final class Step
      extends java.lang.Object

  A step in a path expression

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Step(byte axis, NodeTest nodeTest)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Step` | `addFilter(Expression exp)`
    `void` | `display(int level)` Diagnostic print of expression structure
    `NodeEnumeration` | `enumerate(NodeInfo node, Context context)` Enumerate this step.
    `byte` | `getAxis()`
    `Expression[]` | `getFilters()`
    `NodeTest` | `getNodeTest()`
    `int` | `getNumberOfFilters()`
    `void` | `setFilters(Expression[] filters, int count)`
    `Step` | `simplify()` Simplify the step.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Step

          public Step(byte axis,
              NodeTest nodeTest)

  - ### Method Detail

    - #### addFilter

          public Step addFilter(Expression exp)

    - #### setFilters

          public void setFilters(Expression[] filters,
                        int count)

    - #### getAxis

          public byte getAxis()

    - #### getNodeTest

          public NodeTest getNodeTest()

    - #### getFilters

          public Expression[] getFilters()

    - #### getNumberOfFilters

          public int getNumberOfFilters()

    - #### simplify

          public Step simplify()
                        throws XPathException

      Simplify the step. Return either the same step after simplification, or null, indicating that the step will always give an empty result.
      Throws:
        `XPathException`

    - #### enumerate

          public NodeEnumeration enumerate(NodeInfo node,
                                  Context context)
                                    throws XPathException

      Enumerate this step.
      Parameters:
        `node:` - The node from which we want to make the step
        `context:` - The context for evaluation. Affects the result of positional filters
      Throws:
        `XPathException`

    - #### display

          public void display(int level)

      Diagnostic print of expression structure